#include <errno.h>
#include <inttypes.h>
#include <limits.h>
#include <stdbool.h>
#include <stdio.h>
#include <stdint.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

#define FANCONTROLED_PROGRAM "fancontroled"
#define FANCONTROLED_RUNNING_DIR "/"
#define FANCONTROLED_VERSION "0.1"

#define FANCONTROLED_RETURN_SUCCESS 0
#define E_FANCONTROLED_FAILURE 1
#define E_FANCONTROLED_SENSORS 2
#define E_FANCONTROLED_FILE_ACCESS 3

#define FANCONTROLED_PWM_FAN_OFF 0x00
#define FANCONTROLED_PWM_FAN_MAX 0xFF
#define FANCONTROLED_PWM_FAN_CONTROL_FILE_DATA_LENGTH 3
#define FANCONTROLED_NONEXISTENT_TEMPERATURE -100.00
#define FANCONTROLED_SLEEP_TIME 15

#define FANCONTROLED_DATA_SENSORS_CHAR_ARRAY_MAX_LEN 8

#define FANCONTROLED_DATA_TEMP_MIN 30
#define FANCONTROLED_DATA_TEMP_MAX 50
#define FANCONTROLED_DATA_TEMP_SHUTDOWN 75
#define FANCONTROLED_DATA_PWM_FAN_OFF 0
#define FANCONTROLED_DATA_PWM_FAN_MIN 1
#define FANCONTROLED_DATA_PWM_FAN_MAX 180
#define FANCONTROLED_DATA_SLEEP_TIME 10

typedef struct fancontroled_data {
	sensors_chip_name temp_sensor;
	int temp_sensor_chip_subfeatature_number;
	uint8_t temp_min;
	uint8_t temp_max;
	sensors_chip_name fan_sensor;
	char fan_write_field[FANCONTROLED_DATA_SENSORS_CHAR_ARRAY_MAX_LEN + 1];
	uint8_t pwm_fan_min;
	uint8_t pwm_fan_max;
} fancontroled_data;
